/*
 * Copyright (c) 2020 Alibaba Group Holding Limited
 *
 * Created by tutan, 2020/04/18
 */

#if !defined(__MCDN_CONTEXT2_H__)
#define __MCDN_CONTEXT2_H__

/* hide implementation detail of McdnContext1
 */

namespace NetBit {
class StreamFrameBase;
}

class McdnContext2
{
public:
    McdnContext2(const char *logid);
    virtual ~McdnContext2();

    // config logger and message handler and start
    void Start(const char *rsUrl,
               const char *sfuUrl,
               void *logFunc, void *logParam,
               void *msgHandler, void *msgHandlerParam,
               bool autoReconnect);

    // publish
    void Publish(bool audio, bool video);

    // subscribe
    void Subscribe(unsigned int uid, bool audio, bool video);

    // broadcast: given url, get uid
    unsigned int AddLocalParticipant(const char *url);
    unsigned int AddRemoteParticipant(const char *url);

    int GetUserCount();

    // stop
    void Stop();

    // get a frame
    NetBit::StreamFrameBase * GetOneFrame();

    // send one frame (callee need delete it)
    void SendOneFrame(NetBit::StreamFrameBase *frm);

private:
    char *mLogID;
    void *mpTrueContext;
    void *apiLock;
};

#endif /* __MCDN_CONTEXT2_H__ */
